#pragma once
#include <d3d11.h>

class shadow_map
{
public:

    shadow_map();
    shadow_map(const shadow_map&) = delete;
    shadow_map& operator=(const shadow_map&) = delete;
    ~shadow_map();

    bool initialize(
        ID3D11Device* device,
        int shadow_map_width,
        int shadow_map_height
        );

    void set_render_target(ID3D11DeviceContext* context);
    void clear_render_target(ID3D11DeviceContext* context, float depth);

    ID3D11ShaderResourceView* get_shader_resource_view() const;

    void shutdown();

private:
    ID3D11Texture2D* depth_texture_;
    ID3D11DepthStencilView* depth_stencil_view_;
    ID3D11ShaderResourceView* shader_resource_view_;
    D3D11_VIEWPORT viewport_;

    
};
